
/* nbody_force.h */

#ifndef nbody_force_h
#define nbody_force_h

#include "nbody_utility.h"

#define gravitational_constant  6.6726e-11 /* N(m/kg)^2 */

#define first_force_component_index      0
#define force_x_index                    first_force_component_index
#define force_y_index                    (force_x_index + 1)
#define force_z_index                    (force_y_index + 1)
#define last_force_component_index       force_z_index
#define number_of_force_components                                      \
                                         (last_force_component_index -  \
                                          first_force_component_index + 1)

typedef float Force[number_of_force_components];
typedef Force* ForcePtr;
typedef Force* ForceArray;

#include "nbody_particle.h"

extern ForceArray ForceArray_construct(int number_of_forces);
extern ForceArray ForceArray_destruct(
                      ForceArray this_force_array,
                      int number_of_forces);

extern void Force_calculate(
                Force this_force,
                Particle this_particle1, Particle this_particle2);
extern void ForceArray_calculate(
                ForceArray this_total_force_array,
                ParticleArray this_particle_array, int number_of_particles);

#endif /* #ifndef nbody_force_h */

